package com.jz.dmp.modules.dao;

import com.jz.dmp.modules.model.DmpNavigationTree;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * DMP资源导航树(DmpNavigationTree)表数据库访问层
 *
 * @author makejava
 * @since 2020-12-29 15:08:16
 */
public interface DmpNavigationTreeDao{

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    DmpNavigationTree queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<DmpNavigationTree> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param dmpNavigationTree 实例对象
     * @return 对象列表
     */
    List<DmpNavigationTree> queryAll(DmpNavigationTree dmpNavigationTree);

    /**
     * 新增数据
     *
     * @param dmpNavigationTree 实例对象
     * @return 影响行数
     */
    int insert(DmpNavigationTree dmpNavigationTree);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<DmpNavigationTree> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<DmpNavigationTree> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<DmpNavigationTree> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<DmpNavigationTree> entities);

    /**
     * 修改数据
     *
     * @param dmpNavigationTree 实例对象
     * @return 影响行数
     */
    int update(DmpNavigationTree dmpNavigationTree);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    int countTreeByName(DmpNavigationTree tree);
}